int r, g, b;  //赤、緑、青用の変数
int rWidth, gWidth, bWidth;  //バーの幅

//バーの領域にマウスが入っているかを判定
boolean rFlag, gFlag, bFlag;
int barH = 15;  //バーの高さ
int margin = 50;  //文字表示用のスペース
PFont font;  //文字用変数

void setup() {
  blendMode(LIGHTEST);  //加法混色にするため、ブレンドモードを変更
  size(400, 400);
  noStroke();

  rWidth = gWidth = bWidth = width - margin;  //初期化
  rFlag = gFlag = bFlag = false;

  font = createFont("Arial", 11);
  textFont(font, 11);
}

void draw() {
  background(0);

  //map関数を使ってバーの幅を色(0~255)に変換
  r = int(map(rWidth, 0, width - margin, 0, 255));
  g = int(map(gWidth, 0, width - margin, 0, 255));
  b = int(map(bWidth, 0, width - margin, 0, 255));

  //赤のバーを描画
  fill(255, 0, 0);
  rect(0, 0, rWidth, barH);

  //緑のバーを描画
  fill(0, 255, 0);
  rect(0, barH, gWidth, barH);

  //青のバーを描画
  fill(0, 0, 255);
  rect(0, barH*2, bWidth, barH);

  //赤の円を描画
  fill(r, 0, 0);
  ellipse(150, 180, 200, 200);

  //緑の円を描画
  fill(0, g, 0);
  ellipse(250, 180, 200, 200);

  //青の円を描画
  fill(0, 0, b);
  ellipse(200, 267, 200, 200);

  //右下の四角を描画
  fill(r, g, b);
  rect(370, 370, 30, 30);

  //テキスト描画
  fill(255);
  text("R = " + r, width - margin + 3, barH - 3);
  text("G = " + g, width - margin + 3, barH*2 - 3);
  text("B = " + b, width - margin + 3, barH*3 - 3);
}

void mousePressed() {

  //選択範囲。もしマウスが赤のバーの領域に入ったら、
  if ((mouseX > 0) && (mouseX < width - margin) 
    && (mouseY > 0) && (mouseY < barH)) {

    rWidth = mouseX; //バーの幅をmouseXにする
    rFlag = true;  //赤用フラッグをtrue 

    //緑のバーの領域
  } else if ((mouseX > barH) && (mouseX < width - margin) 
    && (mouseY > 0) && (mouseY < barH*2)) {

    gWidth = mouseX; 
    gFlag = true; 

    //青のバーの領域
  } else if ((mouseX > barH*2) && (mouseX < width - margin) 
    && (mouseY > 0) && (mouseY < barH*3)) {

    bWidth = mouseX; 
    bFlag = true;
  }
}

void mouseDragged() {
  if ( mouseX <= width - margin) {

    //ドラッグしている間はバーの幅を変更する
    if (rFlag) rWidth = mouseX;
    else if (gFlag) gWidth = mouseX;
    else if (bFlag) bWidth = mouseX;
  }
}

void mouseReleased() {
  //マウスを話したらフラッグをfalseにする
  rFlag = gFlag = bFlag = false;
}