float boxSize = 15;    //立方体のサイズ
float distance = 20;    //立方体同士の距離
float halfDis;    //立方体同士の一辺の全体の距離の半分
int boxNum = 10;    //立方体の数
float step = 255/boxNum;  //色を変化させる単位
int angleX = 30;  //x軸を中心とした回転角度の初期値
int angleY = 60;  //y軸を中心とした回転角度

void setup() {
  size(400, 400, P3D);

  //立方体が並んだ際の距離の半分
  halfDis = distance*(boxNum- 1)/2;

  noStroke();
}

void draw() {
  background(0);

  translate(width/2, height/2);    //基準点を画面中央に移動   
  rotateX(radians(-angleX));  //x軸を中心に回転
  rotateY(radians(angleY));  //y軸を中心に回転

  for (int z = 0; z < boxNum; z ++) {    //立方体を、z軸方向に並べる  
    for (int y = 0; y < boxNum; y ++) {    //立方体を、y軸方向に並べる
      for (int x = 0; x < boxNum; x ++) {    //立方体を、x軸方向に並べる

        pushMatrix();

        //一つずつ移動させる
        translate(x*distance - halfDis, y*distance - halfDis, 
          z*distance - halfDis);
        fill(255 - step*x, 255 - step*y, 255 - step*z);  //色を指定する
        box(boxSize, boxSize, boxSize);    //立方体を描く

        popMatrix();
      }
    }
  }
}

void mouseDragged() {

  //マウスをドラッグすることによって立体と回転
  angleX += (mouseY - pmouseY);  //x軸を中心とした回転
  angleY += (mouseX - pmouseX);  //y軸を中心とした回転
  if (angleX < -120) angleX = -120;  //上下は-60度から60度の間しか回転しない
  if (angleX > 0) angleX = 0;
}