int grid = 50;  //グリッドの単位

size(400, 400);
noStroke();

for (int y = 0; y < width; y += grid) {
  for (int x = 0; x < height; x += grid) {

    float sx = float(x)/350.0; // 計算しやすくするため、xの値を0.0-1.0の範囲に限定する
    float sy = float(y)/350.0; // 計算しやすくするため、yの値を0.0-1.0の範囲に限定する
    // float sx = map(x, 0, 350, 0, 1.0); //map関数を使う場合はこのようになる
    // float sy = map(x, 0, 350, 0, 1.0); //map関数を使う場合はこのようになる

    float r, g, b;
    if (x % (grid*2) == 0) { //2回に1回
      r = abs(sx - 0.3); // 赤成分を設定(値sxと数値0.3の絶対値)
      g = abs(sy - 0.6); // 緑成分を設定(値syと数値0.6の絶対値)
      b = 255; // 青成分を設定

      r = map(r, 0, 0.7, 0.4, 1.0); // 上の計算で、値は0.0-0.7を取るようになっているので、
      // 再び0.4-1.0に変換する
      g = map(g, 0, 0.6, 0.4, 1.0); // 上の計算で、値は0.0-0.6を取るようになっているので、
      // 再び0.4-1.0に変換する
    } else {
      r = abs(sx*sy - 0.8); // 赤成分を設定(値sx*syと数値0.8の絶対値)
      g = abs(sx*sy - 0.5); // 緑成分を設定(値sx*syと数値0.5の絶対値)
      b = 255; // 青成分を設定

      r = map(r, 0, 0.8, 0.4, 1.0); // 上の計算で、値は0.0-0.8を取るようになっているので、
      // 再び0.4-1.0に変換する
      g = map(g, 0, 0.5, 0.4, 1.0); // 上の計算で、値は0.0-0.5を取るようになっているので、
      // 再び0.4-1.0に変換する
    }

    fill(r * 255, g * 255, b * 255);  //色を設定
    rect(x, y, grid, grid);
  }
}