float step = 0.01;  //ステップの数値が少ないと変化が滑らかになる
boolean drawFlag = true;  //描画負荷が高いため、毎フレーム描画しないよう、フラグ形式にする

void setup() {
  size(400, 400);
}

void draw() {

  if (!drawFlag) {  //drawFlagがfalseなら
    return;  //この関数を終了する
  } else {
    drawFlag = false;  //次のフレームでは描画しないようにfalseにしておく
  }

  background(0);
  drawBranch(width/2, height/2, PI/2, 1);  //関数drawBranchを実行
}

void drawBranch(float branchX, float branchY, float branchRadians, int branchCount) {
  //branchX: 枝を生やす起点のx座標
  //branchY: 枝を生やす起点のy座標
  //branchRadians: 枝を生やす方向
  //branchCount: 枝の世代

  if (branchCount > 5) {  //枝の世代が5以上なら
    return;  //関数を終了して無限ループを防ぐ
  }

  float p1x = 0;  //lineの点1のx座標  
  float p1y = 0;  //lineの点1のy座標
  float radians = branchRadians;  //lineの角度
  float radius = 0;  //lineの長さ
  float myNoise = random(10.0);  //この枝で使用するノイズ値

  int nextBranchA = 100;  //次の枝を生やす位置その1
  int nextBranchB = 150;  //次の枝を生やす位置その2

  for (int i=0; i<300; i++) {
    radians += (noise(myNoise)- 0.2) * 0.1;  //myNoiseで決定したノイズ値分角度を増やしていく
    radius +=  0.01;  //段階的に半径を拡大していく

    float p2x = p1x + cos(radians) * radius;  //p1からradians角度、radius距離分進んだ位置のx座標
    float p2y = p1y + sin(radians) * radius;  //p1からradians角度、radius距離分進んだ位置のy座標
    float c = 255.0-float(i)/300.0 * 255.0;  //段階的に白色から黒色へ
    stroke(c);

    line(p1x + branchX, p1y + branchY, p2x + branchX, p2y + branchY);
    if (i == nextBranchA || i == nextBranchB) {  //iが次の枝を生やす位置に来たら

      drawBranch(p1x + branchX, p1y + branchY, radians, branchCount+1);  //子枝を生やす
    }

    p1x = p2x;
    p1y = p2y;

    myNoise += step;
  }
}

void mousePressed() {
  drawFlag = true;
}