float step = 0.01;  //ステップの数値が少ないと変化が滑らかになる
boolean drawFlag = true;  //描画負荷が高いため、毎フレーム描画しないよう、フラグ形式にする

void setup() {
  size(400, 400);
}

void draw() {

  if (!drawFlag) {  //drawFlagがfalseなら
    return;  //この関数を終了する
  } else {
    drawFlag = false;  //次のフレームでは描画しないようにfalseにしておく
  }

  background(0);

  //「150本の直線で構成された曲線」を100本描画する
  for (int i=0; i<100; i++) {

    float myNoise = random(10.0);  //この曲線で使うノイズ値
    float cx = width/2;  //円の中央のx座標
    float cy = height/2;  //円の中央のy座標
    float p1x = 0;  //lineの点1のx座標
    float p1y = 0;  //lineの点1のy座標
    float radians = random(TWO_PI);  //角度 (ランダム)
    float radius = 100;  //半径初期値
    float radiusIncrement = noise(myNoise);  //半径の増大量

    for (int j=0; j<150; j++) {

      radians += TWO_PI/300.0;  //角度を増やす
      radius += radiusIncrement; //半径を増やす

      float p2x = cos(radians) * radius;  //lineの点2のx座標
      float p2y = sin(radians) * radius;  //lineの点2のy座標

      if (j > 1) {  //ループが2回目以降なら  (1回目ではまだp1x,p1yが未設定なので)
        float c = 255.0-float(j)/150.0 * 255.0;  // 段階的に白色から黒色へ
        stroke(c);
        line(p1x + cx, p1y + cy, p2x + cx, p2y + cy);
      }
      p1x = p2x;  //次のループのためにx座標を保存
      p1y = p2y;  //次のループのためにy座標を保存

      myNoise += step;
    }
  }
}

void mousePressed() {
  drawFlag = true;
}