float step = 0.01;  //ステップの数値が少ないと変化が滑らかになる
boolean drawFlag = true;  //描画負荷が高いため、毎フレーム描画しないよう、フラグ形式にする

float[] noises = new float[5];  //ノイズ値を5つ分保存するための配列

void setup() {
  size(400, 400);
}

void draw() {

  if (!drawFlag) {
    return;
  } else {
    drawFlag = false;
  }

  for (int i=0; i<5; i++) {
    noises[i] = random(10);  //ノイズ値の配列に数値を入れる
  }

  background(0);
  drawBranch(width/2, height/2, 0, 1);   //関数drawBranchを実行
}

void drawBranch(float branchX, float branchY, float branchRadians, int branchCount) {
  //branchX: 枝を生やす起点のx座標
  //branchY: 枝を生やす起点のy座標
  //branchRadians: 枝を生やす方向
  //branchCount: 枝の世代

  if (branchCount > 2) {  //枝の世代が2以上なら
    return;  //関数を終了して無限ループを防ぐ
  }

  int nextBranch = floor(random(100.0) + 100.0);  //次の枝を生やす位置その1

  //「300本の直線で構成された曲線」を5本描画する
  for (int i=0; i<5; i++) {

    float myNoise = noises[branchCount]+i*0.2;  //この枝で使うノイズ
    float p1x = 0;  //1ループ前のx座標を記録するための変数
    float p1y = 0;  //1ループ前のy座標を記録するための変数
    float radians = branchRadians+ (i/5.0) * TWO_PI;
    float radiansIncrement = (noise(myNoise)- 0.2) * 0.1;  //1ループで増やす角度
    float radius = 0;  //半径

    for (int j=0; j<300; j++) {

      radians += radiansIncrement;  //角度を増やす
      radius +=  0.01;  //半径を増やす
      float p2x = p1x + cos(radians) * radius;  //p1からradians方向にradius距離進んだ位置のx座標
      float p2y = p1y + sin(radians) * radius;  //p1からradians方向にradius距離進んだ位置のy座標
      float c = 255.0-float(j)/300.0 * 255.0;  //段階的に白色から黒色に
      stroke(c);
      line(p1x + branchX, p1y + branchY, p2x + branchX, p2y + branchY);

      if (j == nextBranch ) {  //jが次に枝を生やす位置なら
        drawBranch(p1x + branchX, p1y + branchY, radians, branchCount+1);  //枝を生やす
      }

      p1x = p2x;  //次のループのためにx座標を保存しておく
      p1y = p2y;  //次のループのためにy座標を保存しておく

      myNoise += step;
    }
  }
}

void mousePressed() {
  drawFlag = true;
}