float noisePoint1X = 1.0;  //アンカーポイント1のx座標用ノイズ変数
float noisePoint1Y = 4.0;  //アンカーポイント1のy座標用ノイズ変数
float noisePoint1Step = 0.001;  //アンカーポイント1のステップ

float noisePoint2X = 2.0;  //アンカーポイント2の各種変数
float noisePoint2Y = 9.0;  
float noisePoint2Step = 0.003;

float shiftX = 0;  //点の全体的な右下への移動のスピードを作るためのx方向用ずれ変数
float shiftY = 0;  //点の全体的な右下への移動のスピードを作るためのy方向用ずれ変数
float noiseSpeedX = 5.0;  //点の全体的な右下への移動のスピードを作るためのx方向用ノイズ変数
float noiseSpeedY = 15.0;  //点の全体的な右下への移動のスピードを作るためのy方向用ノイズ変数
float noiseSpeedStep = 0.001;  //点の全体的な右下への移動のスピードを作るためのステップ

float interval = 20.0;  //点の間隔

void setup() {
  size(400, 400);
  background(0);
}

void draw() {

  background(0);

  //軌跡を残す場合は、下の3行をON、backgroundをOFFにする
  /*
  fill(0, 20);  //透明度のあるrectを描画
   rect(0, 0, width, height);
   fill(0);      //オブジェクトは黒
   */

  for (int i=0; i<42; i++) {
    for (int j=0; j<42; j++) {

      float x = (i - 10) * interval + shiftX;  //ノイズを使ってx座標を設定
      float y = (j - 10) * interval + shiftY;  //ノイズを使ってy座標を設定
      /* //点の本来の位置を知るためのコメントアウト(青色で表示される)
       fill(0,0,250);
       ellipse(x, y, 4, 4);
       */

      float anchorPoint1X = noise(noisePoint1X)*width*3 - width;  //ノイズを使ってアンカーポイント1のx座標を設定
      float anchorPoint1Y = noise(noisePoint1Y)*height*3 - height;  //ノイズを使ってアンカーポイント1のy座標を設定
      /* //アンカーポイント1の位置を知るためのコメントアウト (赤色で表示される)
       fill(250,0,0);
       ellipse(anchorPoint1X, anchorPoint1Y, 10, 10);
       */

      float dx1 = abs(x - anchorPoint1X);  //アンカーポイント1と点のx座標の差分
      float dy1 = abs(y - anchorPoint1Y);  //アンカーポイント1と点のy座標の差分
      float distance1 = sqrt(dx1*dx1 + dy1*dy1);  //アンカーポイント1と点の距離

      float anchorPoint2X = noise(noisePoint2X)*width*3 - width;  //ノイズを使ってアンカーポイント2のx座標を設定
      float anchorPoint2Y = noise(noisePoint2Y)*height*3 - height;  //ノイズを使ってアンカーポイント2のy座標を設定
      /* //アンカーポイント2の位置を知るためのコメントアウト (赤色で表示される)
       fill(250,0,0);
       ellipse(anchorPoint2X, anchorPoint2Y, 10, 10);
       */

      float dx2 = abs(x - anchorPoint2X);  //アンカーポイント2と点のx座標の差分
      float dy2 = abs(y - anchorPoint2Y);  //アンカーポイント2と点のy座標の差分
      float distance2 = sqrt(dx2*dx2 + dy2*dy2);  //アンカーポイント2と点の距離


      //点の本来のx座標(変数x)から、アンカーポイント2つとの距離に応じて歪ませたx座標
      float fx = x + cos(distance1/width*TWO_PI)*50 + cos(distance2/width*TWO_PI)*50; 
      //点の本来のy座標(変数y)から、アンカーポイント2つとの距離に応じて歪ませたy座標 
      float fy = y + sin(distance1/height*TWO_PI)*50 + sin(distance2/height*TWO_PI)*50;

      noStroke();
      fill(255);
      rect(fx, fy, 2, 2);  //描画
    }
  }

  shiftX += (noise(noiseSpeedX) + 1)*1.4;  //点のx方向の移動
  if (shiftX >= interval) {  //行ったっきりにならないよう、点の間隔の距離を超えたら、その分差し引いて元に戻す
    shiftX = shiftX%interval;
  }
  shiftY += (noise(noiseSpeedY) + 1)*2;  //点のy方向の移動
  if (shiftY >= interval) {  //行ったっきりにならないよう、点の間隔の距離を超えたら、その分差し引いて元に戻す
    shiftY = shiftY%interval;
  }

  //ノイズの値を更新
  noisePoint1X += noisePoint1Step;
  noisePoint1Y += noisePoint1Step;
  noisePoint2X += noisePoint2Step;
  noisePoint2Y += noisePoint2Step;
  noiseSpeedX += noiseSpeedStep;
  noiseSpeedY += noiseSpeedStep;
}