int num = 1000;//線の個数
PVector []pos = new PVector[num];//線の位置
PVector []ppos = new PVector[num];//前のフレームの位置
PVector []vel= new PVector[num];//速度
PVector []axis = new PVector[num];//方向
int count = 0;//フレーム数をカウント

void setup() {
  size(500, 500);
  frameRate(60); 

  float randomAxis = random(-1, 1);//ランダムに方向を求める

  //半径100の円周の位置を設定する
  for (int  i = 0; i < num; i++) {    
    float theta = map(random(0, 1.0), 0, 1, 0, TWO_PI*13);//ランダムな値を利用して角度を求める
    int radius = 100;//半径を設定
    pos[i] = new PVector(width/2+cos(theta)*radius, height/2+sin(theta)*radius);
    ppos[i] = new PVector(width/2+cos(theta)*radius, height/2+sin(theta)*radius);
    vel[i] = new PVector(0, 0);
    axis[i] = new PVector(randomAxis, randomAxis);
  }

  background(0);
}

void draw() {

  //一定間隔でパラメーターをリセットする
  if (count > 60 * 1.6) {

    float randomAxis = random(-1, 1);

    //半径100の円周の位置を設定する
    for (int  i = 0; i < num; i++) {
      noiseSeed((int)random(0, 100));//ノイズの種を設定して違うノイズを生成する  
      float theta = map(random(0, 1.0), 0, 1, 0, TWO_PI*13);//ランダムな値を利用して角度を求める
      int radius = 100;//半径を設定
      pos[i] = new PVector(width/2+cos(theta)*radius, height/2+sin(theta)*radius);
      ppos[i] = new PVector(width/2+cos(theta)*radius, height/2+sin(theta)*radius);
      vel[i] = new PVector(0, 0);
      axis[i] = new PVector(randomAxis, randomAxis);
    }
    background(0);
    count = 0;
  }
  count++;


  for (int i = 0; i < num; i++) {
    ppos[i] = pos[i].copy();

    float noiseVal = noise(0.0003*pos[i].x, 0.0003*pos[i].y);//ノイズの値の更新
    float theta = map(noiseVal, 0, 1, 0, TWO_PI*13);//ノイズを使って角度の更新        
    vel[i] = axis[i].copy();//方向の値をコピー
    vel[i].set(vel[i].x*cos(theta), vel[i].y*sin(theta));//速度の更新
    vel[i].mult(10.5);

    pos[i].add(vel[i]);//位置の更新

    //線の描画
    stroke(255, 30);
    strokeWeight(1.5);
    noFill();
    line(ppos[i].x, ppos[i].y, pos[i].x, pos[i].y);
  }
}