float x, y;  //x, y座標
float A;  //振幅
float w;  //角周波数（周期）
float p1;  //静止画用初期位相
float p2;  //動画用初期位相
float t2;  //アニメーション用経過時間（X座標）

//1秒で1回転するように30で割る。度数法だと12°
//更に3で割ると1周期3秒
float rad = (TWO_PI/30.0)/3;
float myScale = 100.0;  //画面上で見やすいように拡大

void setup() {
  size(720, 400);
  frameRate(30);

  A = 100.0;    //振幅を設定
  w = 1.0;    //角周波数を設定
  p1 = 0.0;    //初期位相を設定
  p2 = 0.0;    //初期位相を設定
  t2 = 0.0;    //経過時間を初期化
}

void draw() {
  background(255);

  myCoordinates();   //基準線

  noStroke();
  fill(0);

  //サイン波を点で静止画として描画///////////////////////////
  for (float t1 = 0.0; t1 < TWO_PI; t1 += rad) {
    x = t1*myScale;
    y = -A*sin(w*t1 + p1);
    ellipse(x, y + height/2, 1, 1);
  }

  //点のアニメーションを描画////////////////////////////////  
  x = t2*myScale;
  y = -A*sin(w*t2 + p2);
  ellipse(x, y + height/2, 10, 10);

  t2 += rad;    //時間を進める
  if (t2 > TWO_PI) t2 = 0.0;    //1周期分終わったら原点に戻る
}

//座標表示用関数
void myCoordinates() {

  stroke(200);
  for (int i = 0; i < width; i += 0.5*PI*myScale)
    line(i, 0, i, height);  //縦線
  for (int i = 0; i < height; i += 50) 
    line(0, i, width, i);  //横線

  stroke(255, 0, 0);
  line(0, height/2, width, height/2);  //横の中央線
}