float[] x = new float[100];  //円のx座標
float[] y = new float[100];  //円のy座標
float[] eSize = new float[100];  //円のサイズ
int counter = 0;  //配列に値を順番に入れるためのカウンター
boolean mouseFlag = false;  //マウスが押されているかを判定するフラッグ
 
void setup() {
  size(400, 400);
  background(255);
  noStroke();
  fill(0);
 
  //x[]、y[]、eSize[]を初期化
  for (int i = 0; i<x.length; i++) {
    x[i] = y[i] = eSize[i] = 0;
  }
}
 
void draw() {
  background(255);
 
  //軌跡を残す場合は、下の3行をON、backgroundをOFFにする
  /*
  fill(255, 10);  //透明度のあるrectを描画
  rect(0, 0, width, height);
  fill(0);      //オブジェクトは黒
  */
 
  //マウスが押されていなければ描画
  if (!mouseFlag) {
 
    ellipse(x[counter], y[counter], eSize[counter], eSize[counter]);
 
    counter ++;
    if (counter > x.length-1) counter = 0;
  }
}
 
void mousePressed() {
  background(255);
 
  counter = 0;  //マウスが押されたらカウンターを初期化
  mouseFlag = true;  //フラッグをON
}
 
void mouseDragged() {
  x[counter] = mouseX;  //マウスの座標を記録
  y[counter] = mouseY;
 
  //スピードを記録してeSizeにする
  eSize[counter] = dist(mouseX, mouseY, pmouseX, pmouseY)*2;
  counter ++;  //カウンターを加算
 
  //カウンターは配列のインデックス番号の最大値で止まる
  if (counter >= x.length-1) counter = x.length-1;
}
 
void mouseReleased() {
  //カウンター分までは保存して、それ以外は初期化
  for (int i = counter; i < x.length; i ++) {
    x[i] = 0;
    y[i] = 0;
    eSize[i] = 0;
  }  
  mouseFlag = false;  //マウスフラッグはOFF
}