import processing.video.*;

Capture video;

void setup() {
  // 640 x 480が大きすぎて遅かったら、320 x 240に変更する
  size(640, 480);

  //画面サイズのキャプチャ画像を生成。
  //パソコンの性能によっては画面がコマ落ちするので、
  //その場合は、一番右の数値のフレームレートを上げる。
  video = new Capture(this, width, height, 90);
  video.start();
  loadPixels();    //画面に画像のピクセルを展開
}

void draw() {
  background(0);

  if (video.available()) {  //もしキャプチャができたら、
    video.read(); //ビデオフレームの読み込み
    video.loadPixels(); //ビデオのピクセルを操作できるようにする

    //1ピクセルごとに色を調べる。
    for (int y = 0; y < video.height; y ++) {
      for (int x = 0; x < video.width; x ++) {
        //ビデオのピクセルを抜き出す
        int pixelColor = video.pixels[y*video.width + x];

        //赤、緑、青をそれぞれ抽出する。
        //以下の3行はビットシフトといって、
        //理解するのが結構大変なので、ここでは詳細は説明しない。
        int r = (pixelColor >> 16) & 0xff;
        int g = (pixelColor >> 8 ) & 0xff;
        int b = pixelColor & 0xff;

        //グレー
        r = g = b = (r + g + b)/3; //明暗を抽出

        //色の反転
        /*
        r = 255 - r;
         g = 255 - g;
         b = 255 - b;
         */

        //2色に変換
        //もし、ピクセルの明度127以上だったら
        /*
        if((r + g + b)/3 >= 127){
         
         r = 255; g = 255; b = 255;  //白にする
         }else{
         r = 255; g = 0; b = 0;  //それ以外は赤にする        
         }
         */

        //ウィンドウのピクセルの色を決定
        pixels[y*video.width + x] = color(r, g, b);
      }
    }
    updatePixels();    //画像を更新
  }
}