import processing.video.*;
 
Capture video;
int row = 0;  //行番号
 
void setup() {
  // 640 x 480が大きすぎて遅かったら、320 x 240に変更する
  size(640, 480);
 
  //画面サイズのキャプチャ画像を生成。
  //パソコンの性能によっては画面がコマ落ちするので、
  //その場合は、一番右の数値のフレームレートを上げる。
  video = new Capture(this, width, height, 90);
  video.start();
  loadPixels();    //画面に画像のピクセルを展開
}
 
void draw() {
  if (video.available()) {  //もしキャプチャができたら、
    video.read(); //ビデオフレームの読み込み
    video.loadPixels(); //ビデオのピクセルを操作できるようにする
 
    //1ピクセルごとに色を調べる。
    for (int x = 0; x < video.width; x ++) {
      //1行のビデオのピクセルを抜き出す
      int pixelColor = video.pixels[row*video.width + x];
 
      //赤、緑、青をそれぞれ抽出する。以下の3行はビットシフトというが、
      //ここでは詳細は説明しない。
      int r = (pixelColor >> 16) & 0xff;
      int g = (pixelColor >> 8 ) & 0xff;
      int b = pixelColor & 0xff;
 
      //ウィンドウのピクセルの色を決定
      pixels[row*video.width + x] = color(r, g, b);
    }
    updatePixels();    //画像を更新
 
    row ++;  //行を下に移動
    if (row >= height) row = 0;  //画面の最後まで行ったら元に戻す。
  }
}