import processing.video.*;

Capture video;
int column = 0;  //列番号

void setup() {
  // 640 x 480が大きすぎて遅かったら、320 x 240に変更する
  size(640, 480);

  //画面サイズのキャプチャ画像を生成。
  //パソコンの性能によっては画面がコマ落ちするので、
  //その場合は、一番右の数値のフレームレートを上げる。
  video = new Capture(this, width, height);
  video.start();
  loadPixels();    //画面に画像のピクセルを展開
}

void draw() {
  if (video.available()) {  //もしキャプチャができたら、
    video.read(); //ビデオフレームの読み込み
    video.loadPixels(); //ビデオのピクセルを操作できるようにする

    //1ピクセルごとに色を調べる。
    for (int y = 0; y < video.height; y ++) {
      //1行のビデオのピクセルを抜き出す
      int pixelColor = video.pixels[y*video.width + column];

      //赤、緑、青をそれぞれ抽出する。以下の3行はビットシフトというが、
      //ここでは詳細は説明しない。
      int r = (pixelColor >> 16) & 0xff;
      int g = (pixelColor >> 8 ) & 0xff;
      int b = pixelColor & 0xff;

      //ウィンドウのピクセルに当てはめる
      pixels[y*video.width + (video.width - column - 1)] 
        = color(r, g, b);
    }
    updatePixels();    //画像を更新

    column ++;  //行を下に移動
    if (column >= width) column = 0;  //画面の最後まで行ったら元に戻す。
  }
}