float y;           //オブジェクトのy座標
float k = 0.1;     //ばねの強さ
float damp = 0.9;  //摩擦による減衰率
float velY = 0.0;  //y方向のスピード
float targetY;     //移動位置のy座標
float force = 0;   //ばねの反発力
 
void setup() {
 
  size(400, 400);
  background(255);
  noStroke();
  fill(0);
 
  targetY = width/2;  //移動位置は画面中央
  y = 100;             //開始時のオブジェクトのy座標は0
}
 
void draw() {
 
  //フェードする時はtrue、しない場合はfalse
  fade(false);
 
  force = -k*(y - targetY);    //ばねの力を計算（F = -kx）
  velY = damp*(velY + force);  //摩擦によって減衰する
  y += velY;                     //オブジェクトを移動
  ellipse(width/2, y, 40, 40);   //円を描画
}
 
//クリックでtargetをマウス座標にする
void mousePressed() {
  targetY = mouseY;
} 
 
//フェード用関数
void fade(boolean _fadeFlag) {
  if (_fadeFlag) {
    fill(255, 10);  //透明度のあるrectを描画
    rect(0, 0, width, height);
    fill(0);      //オブジェクトは黒
  } else {
    background(255);
  }
}