float x, y;           //オブジェクトのy座標
float mass = 2.5;  //オブジェクトの質量
float k = 0.1;     //ばねの強さ（ばね定数）
float damp = 0.9;  //摩擦による減衰率
float velX, velY;  //y方向のスピード
float targetX, targetY;     //移動位置のy座標
float accelX, accelY;   //加速度
float forceX, forceY;   //ばねの反発力 
 
void setup() {
  size(400, 400);
  background(255);
  noStroke();
  fill(0);
 
  targetX = x = width/2;  //移動位置は画面中央
  targetY = y = height/2;  //移動位置は画面中央
}
 
void draw() {
  //フェードする時はtrue、しない場合はfalse
  fade(false);
 
  targetX = mouseX;
  targetY = mouseY;
 
  //x座標
  forceX = k*(targetX - x);      //ばねの反発力を計算（F=kx）
  accelX = forceX/mass;          //重さによる加速度を計算
  velX = damp*(velX + forceX);   //摩擦による減衰を計算
  x += velX;                       //オブジェクトを移動
 
  //y座標
  forceY = k*(targetY - y);
  accelY = forceY/mass; 
  velY = damp*(velY + forceY);
  y += velY;
 
  ellipse(x, y, 40, 40);   //円を描画
}
 
//フェード用関数
void fade(boolean _fadeFlag) {
  if (_fadeFlag) {
    fill(255, 10);  //透明度のあるrectを描画
    rect(0, 0, width, height);
    fill(0);      //オブジェクトは黒
  } else {
    background(255);
  }
}