float objX, objY; //オブジェクトの座標
float velX, velY;  //オブジェクトのスピード

void setup() {
  size(400, 400);
  background(255);
  noStroke();
  fill(0);

  objX = objY = velX = velY = 0.0; //初期化
}

void draw() {
  //フェードする時はtrue、しない場合はfalse
  fade(false);

  objX += velX;    //x、y座標にvelX, velYの値を足す
  objY += velY;

  //このコードを実行すると、オブジェクトがバウンドする
  if (objX > width || objX < 0) {  //x方向に折り返す
    velX = -velX;
  }
  if (objY > height || objY < 0) {  //y方向に折り返す
    velY = -velY;
  }
  ///////////////////////////////////////

  ellipse(objX, objY, 20, 20);  //ellipseを描画
}

void mouseDragged() {
  objX = mouseX;  //オブジェクトがマウスに追従する
  objY = mouseY;
}

void mouseReleased() {
  //pmouseXは前のフレームのマウスのx座標。
  //この計算でマウスを動かしたスピードがわかる
  velX = mouseX - pmouseX;
  velY = mouseY - pmouseY;
}

//フェード用関数
void fade(boolean _fadeFlag) {
  if (_fadeFlag) {
    fill(255, 10);  //透明度のあるrectを描画
    rect(0, 0, width, height);
    fill(0);      //オブジェクトは黒
  } else {
    background(255);
  }
}