float objX, objY;    //オブジェクトのx, y座標
float disX, disY;    //mouse座標とオブジェクトの距離
//マウスに遅れる度合い（2.0だと速すぎて見えないので20.0にしておく）
float delay = 20.0;
float targetX, targetY;  //円の到達点
float rad;  //円とマウス座標までの角度
float distance;  //円とマウス座標の距離
float range = 100.0;  //円が反応するマウス座標までの距離

void setup() {
  size(400, 400);
  background(255);

  //現在のマウス座標で初期化
  targetX = objX = width / 2;
  targetY = objY = height / 2;
}

void draw() {
  //フェードする時はtrue、しない場合はfalse
  fade(false);

  noFill();
  stroke(0);
  rect(20, 20, width - 40, height - 40);

  //円からマウス座標までの角度
  rad = atan2(objY - pmouseY, objX - pmouseX);
  //円からマウス座標までの距離
  distance = dist(mouseX, mouseY, objX, objY);

  //距離がrange以内だったら新しい到達点を設定
  if (distance < range) {

    //objX, Yの値に新しく距離を加算
    targetX = objX + distance*cos(rad);
    targetY = objY + distance*sin(rad);
  }

  //マウス座標とオブジェクトの距離をdisX, disYに入れる
  disX = targetX - objX;
  disY = targetY - objY;

  //距離をdelayで割った値を足す（オブジェクトが移動する）
  objX += disX/delay;
  objY += disY/delay;

  //円は、画面の上下左右20pxで止まる
  objX = min(max(objX, 20), width - 20);
  objY = min(max(objY, 20), height - 20);

  fill(0);
  ellipse(objX, objY, 20, 20);
}

//フェード用関数
void fade(boolean _fadeFlag) {
  if (_fadeFlag) {
    fill(255, 10);  //透明度のあるrectを描画
    rect(0, 0, width, height);
    fill(0);      //オブジェクトは黒
  } else {
    background(255);
  }
}