boolean drawFlag = true;  //描画を行うタイミングかどうかを決定する。

void setup() {
  size(400, 400);
}

void draw() {

  if (drawFlag) {  //描画タイミングであれば

    background(255);
    float cx = width/2;  //円の中心(x)
    float cy = height/2;  //円の中心(y)
    float innerRadius = 0;  //内側の渦の半径
    float outerRadius = 0;  //外側の渦の半径

    float innerRadiusBlur = 0;  //内側の渦の半径の歪み最大値
    float outerRadiusBlur = 0;  //外側の渦の半径の歪み最大値
    float innerRadiusBlurTarget = 0;  //内側の渦の半径の歪み最大値の目標値
    float outerRadiusBlurTarget = 10;  //内側の渦の半径の歪み最大値の目標値
    float angle = 0.1;  //内側の渦と外側の渦を接続する線の傾き
    float angleTarget = 0.1;  //内側の渦と外側の渦を接続する線の傾きの目標値

    for (int i=0; i<200; i++) {

      innerRadius += 1.3;  //内側の渦の半径を段階的に大きくしていく
      outerRadius += 2.3;  //内側の渦の半径を段階的に大きくしていく

      if (random(20) > 18) {  // 10%の確率で
        innerRadiusBlurTarget = random(30);  //内側の歪み最大量を変更する 最低0 -> 最大30
      }
      if (random(20) > 18) {  // 10%の確率で
        outerRadiusBlurTarget = 30 + random(30);  //外側の歪み最大量を変更する 最低30 -> 最大60
      }
      if (random(20) > 19) {  // 5%の確率で
        angleTarget = random(PI)*0.3 + 0.2;  //内側の渦と外側の渦を接続する線の傾きの目標値を変更する 最低0.2 -> 最大 πの30%+0.2
      }

      innerRadiusBlur += (innerRadiusBlurTarget - innerRadiusBlur)/10.0;  //目標値に向かってイージングをかけながら近づけていく
      outerRadiusBlur += (outerRadiusBlurTarget - outerRadiusBlur)/10.0;  //目標値に向かってイージングをかけながら近づけていく
      angle += (angleTarget - angle)/20.0;  //目標値に向かってイージングをかけながら近づけていく

      //p1は内側の渦の位置を決定する
      float radian = TWO_PI / 100.0 * i;  //角度 0 -> 4π (720度)
      float radius = innerRadius + innerRadiusBlur;  //半径 基本値 + ブレ値
      float p1x = cos(radian) * radius + cx; 
      float p1y = sin(radian) * radius + cy; 

      //p2は内側の渦の位置を決定する
      radian += angle;  //内側の角度に「内側の渦と外側の渦を接続する線の傾き」を加算する
      radius = outerRadius + outerRadiusBlur;  //半径 基本値 + ブレ値
      float p2x = cos(radian) * radius + cx; 
      float p2y = sin(radian) * radius + cy; 

      line(p1x, p1y, p2x, p2y);
    }
    drawFlag = false;  //描画が終了したのでフラグをfalseにしておく
  }
}
void mousePressed() {
  drawFlag = true;  //描画タイミングにする
}