float theta = 0.0;    //角度
int lightFlag = 1;
 
//1秒で1回転するように30で割る。度数法だと12°
//更に6で割ると1周期6秒
float rad = (TWO_PI/30.0)/6;
 
void setup() {
  size(400, 400, P3D);
  frameRate(30);  //1秒30フレーム
  noStroke();
}
 
void draw() {
  background(0);
  ambientLight(10, 10, 10);  //赤の環境光
 
  //立体の中心を画面中央に移動
  translate(width/2, height/2); 
  rotateX(-PI/6);  //X軸に対して-30°分だけ回転
 
  if (lightFlag == 1) {
 
    //directionalLight(赤, 緑, 青, x方向, y方向, z方向);
    //x, y, z方向は光源の位置。-1.0 ~ 1.0
    directionalLight(0, 255, 0, 0, 0.5, -1);
 
  } else if (lightFlag == 2) {
 
    //pointLight(赤, 緑, 青, x座標, y座標, z座標);
    pointLight(255, 0, 0, -200, 0, 200);
 
  } else if (lightFlag == 3) {
 
    spotLight(0, 0, 255,    //赤, 緑, 青
              0, -200, 0,   //光源のx, y, z座標
              0, 1, 0,      //光の方向
              PI/9,         //スポットの角度（ここでは20°）
              10);          //光の集まり度合い
  }
  
  rotateY(theta);                //Y軸に対してtheta分だけ回転
  //box(150, 150, 150);    //150x150x150pxの立方体を描く
  sphere(75);
  theta += rad;    //時間を進める
  if (theta > TWO_PI) theta = 0.0;    //1周期分終わったら原点に戻る
}
 
void keyPressed() {
 
  switch(key) {
 
  case '1':  //1を押したら、directionalLight   
    lightFlag = 1;
    break;
  case '2':    //2を押したら、pointLight
    lightFlag = 2;
    break;    
  case '3':    //3を押したら、spotLight
    lightFlag = 3;
    break;
  }
}