//Circleクラスのインスタンスを宣言
Circle c1, c2;

void setup() {
  size(400, 400);
  noStroke();
  fill(0);    //黒で描画

  //インスタンスを作成
  c1 = new Circle(100, 10, 1.0);
  c2 = new Circle(300, 40, 3.5);
}

void draw() {
  background(255);    //背景は白

  //c1インスタンスのクラスであるCircleクラスのupdate(), 
  //display()メソッドを実行
  c1.update(); 
  c1.display();

  c2.update(); 
  c2.display();
}

//Circleクラスの宣言
class Circle {
  float x, y, eSize, velocity;

  //初期化用メソッド（コンストラクタ） 
  Circle (float _y, int _eSize, float _velocity) {
    x = 0.0;    //x座標の初期値は0.0
    y = _y;     //y座標の初期値はインスタンス生成の際の引数
    eSize = _eSize;
    //velocityの初期値はインスタンス生成の際の引数
    velocity = _velocity;
  }

  //円の位置を更新するメソッド
  void update() {
    x += velocity;    //velocity分のx座標を移動
    if (x > width) {    //円のx座標がウィンドウの幅を超えたら、
      x = 0;    //位置を0に戻す
    }
  }

  void display() {
    ellipse(x, y, eSize, eSize);    //円を描く
  }
}