//40個のインスタンスを作成
Circle[] circles = new Circle[40];
 
void setup() {
  size(400, 400);
  fill(0);    //黒で描画
 
  //インスタンスを作成
  for (int i = 0; i < circles.length; i ++) {
    circles[i] = new Circle(random(width), random(height), 5, 
      random(1.0, 10.0), random(1.0, 10.0));
  }
}
 
void draw() { 
  background(255);    //背景は白
 
  //インスタンスのupdateメソッドを実行
  for (int i = 0; i < circles.length; i ++) {
    circles[i].update();
    circles[i].display();
  }
} 
 
//Circleクラスの宣言
class Circle { 
  float x, y, xVel, yVel; 
  int eSize;
 
  //初期化用メソッド（コンストラクタ）
  Circle (float _x, float _y, int _eSize, float _xVel, float _yVel) {
 
    x = _x;    //x, y座標の初期値はインスタンス生成の際の引数
    y = _y;
    eSize = _eSize;
    xVel = _xVel;     //xVel, yVelの初期値もインスタンス生成の際の引数
    yVel = _yVel;
  }
 
  //円の位置を更新するメソッド
  void update() {
    x += xVel;    //xVel, yVel分の座標を移動
    y += yVel;
 
    if (x > width) {    //円のx座標がウィンドウの幅を超えたら、
      x = 0;    //位置を0に戻す
    } else if (y > height) {    //円のy座標がウィンドウの幅を超えたら、
      y = 0;    //位置を0に戻す
    }
  }
 
  void display() {
    ellipse(x, y, eSize, eSize);    //円を描く
  }
}