int count = 0;  //マウスクリックによって生まれる円の順番
 
//Circleクラスのcirclesインスタンスを宣言
Circle[] circles = new Circle[40];   //20個のインスタンスを作成 
 
void setup() {
  size(400, 400);  
  background(255);
  noStroke();
  fill(0);
 
  // circlesインスタンスの生成と配列の初期化
  for (int i = 0; i < circles.length; i++) circles[i] = new Circle();
}
 
void draw() {
  background(255);
 
  //常にcircles[]を更新
  for (int i = 0; i < circles.length; i++) {
    circles[i].update();
    circles[i].display();
  }
}
 
void mouseDragged () {
  circles[count].updatePos(mouseX, mouseY);
}
 
//マウスドラッグによるイベント
void mouseReleased () {
  circles[count].updateVelocity(mouseX - pmouseX, mouseY - pmouseY);
 
  count ++;   //順番に更新
  if (count >= circles.length) count = 0;
}
 
// Circle クラスを作成
//////////////////////////////////////////////////////////
class Circle {
  float x;  //円のx座標
  float y;  //円のy座標
  float radius;  //円の直径
  float xVel;  //x軸方向のスピード
  float yVel;  //y軸方向のスピード
 
  //初期化用メソッド（コンストラクタ）
  Circle() {
    xVel = 0.0;  //スピードの初期値は0.0
    yVel = 0.0;
    x = width / 2;  //x,yは画面の中心に設定
    y = height / 2;
    radius = 20.0;  //円のサイズを設定
  }
 
  //円の描画更新用メソッド
  void  update() {
    // velocityで設定された値を足す
    x += xVel;
    y += yVel;
    if (x > width || x < 0 ) xVel = -xVel;
    if (y > width || y < 0 ) yVel = -yVel;
  }
 
  //円の位置を更新するメソッド
  void updatePos(float _x, float _y) {
    x = _x;
    y = _y;
  }
 
  //円のスピードを更新するメソッド
  void updateVelocity(float _xVel, float _yVel) {
    xVel = _xVel;
    yVel = _yVel;
  }
 
  void display() {
    ellipse(x, y, radius, radius);  //円を描画
  }
}