class Rect { 
  float x, y;    //x座標、y座標
  float rad;    //正方形の回転角度
  int rSize;    //正方形のサイズ
  float velocity;    //移動スピード

  //コンストラクタ
  Rect(float _y, int _rectSize, float _velocity) {
    rectMode(CENTER);    //基準点を正方形の中心にする
    x = 0.0;  
    y = _y;
    rad = 0.0;
    rSize = _rectSize;
    velocity = _velocity;
  }

  //更新メソッド
  void update() { 
    noFill();

    x += velocity;    //velocity分のx座標を移動
    if (x > width) {    //円のx座標がウィンドウの幅を超えたら、
      x = 0;    //位置を0に戻す
    }
  }

  //表示メソッド
  void display() {   
    pushMatrix();    //座標を保存
    translate(x, y);    //基準点を移動
    rotate(rad);    //回転
    rect(0, 0, rSize, rSize);    //正方形を描画
    popMatrix();    //座標を復帰
    rad += 0.01;
  }
}