float[] temp;    //気温
float highTemp;  //最高気温
float lowTemp;  //最低気温
float barW = 40;            //バーの幅
float barH = 200;            //バーの高さ
XML xml;
 
void setup() {
  size(480, 200);
  colorMode(HSB, 360, 100, 100);  //HSBモードにする
  noStroke();
  loadData();  //xmlファイルからデータ読み込み、オブジェクト化
 
  //一番低い気温と高い気温をtemp配列内で検索し、
  //lowTemp、highTempに入れる
  lowTemp = min(temp);
  highTemp = max(temp);
}
 
void draw() {
  background(0, 0, 100);
 
  for (int i = 0; i < temp.length; i ++) {
 
    float x = i*barW;  //x座標を決定
 
    //気温を色に変換
    fill(createColor(temp[i], lowTemp, highTemp), 100, 100);
    rect(x, 0, barW, barH);
  }
}
 
void loadData() {
 
  xml = loadXML("weather_month.xml");  //ファイルの読み込み
 
  //weatherタグ内の要素を取得
  XML[] children = xml.getChildren("weather");
 
  //要素数を取得して配列を生成
  temp = new float[children.length];
 
  //配列に値を入れる
  for (int i = 0; i < temp.length; i++) {
 
    //気温
    XML tempXml = children[i].getChild("temp");
    temp[i] = tempXml.getFloatContent();
  }
}
 
//気温から色を決定
float createColor(float _temp, float _lowTemp, float _highTemp) {
 
  //最低気温から最高気温の範囲を、色相の200°から0°に変換
  //気温を色に変換
  float barColor = map(_temp, _lowTemp, _highTemp, 200, 0);
 
  return barColor;
}