class Bar {

  String date;             //日付
  float temp;            //気温
  float barW;            //バーの幅
  float barH;            //バーの高さ
  float x, y;            //バーのx, y座標
  float resize = 45.0;   //拡大率
  float barColor;        //バーの色
  float margin = 25;    //余白
  boolean over = false;  //マウスがバーの上にあるかを判定
  float space = 1;       //バー同士の隙間

  //コンストラクタ（初期化）
  Bar(String _date, float _temp, int _num, int _length) {
    date = _date;
    temp = _temp;
    barW = (width - margin*2 - space*(_length - 1))/float(_length);
    barH = 200;
    x = _num*(barW + space) + margin;  //バーのx座標を計算
    y = margin;  //バーのy座標を計算
  }

  //気温から色を決定
  void createColor(float _lowTemp, float _highTemp) {

    //最低気温から最高気温の範囲を、色相の200°から0°に変換
    //気温を色に変換
    barColor = map(temp, _lowTemp, _highTemp, 200, 0);
  }

  //バーを表示
  void display() {

    if (over) fill(barColor, 100, 100);  //マウスオーバの場合のバーの色
    else fill(barColor, 40, 100);
    
    rect(x, y, barW, barH);  //バーを描画
  }

  //マウスオーバーイベント用メソッド
  void mouseOver(int mx, int my) {

    //バーの範囲内にマウスがあったら、over = true、テキスト表示
    if ((mx > x) && (mx < x + barW) && (my > y) && (my < y + barH)) {

      over = true;
      
      fill(0, 0, 20);      
      text("気温" + temp + "℃", x + barW/2, y - 8);  //気温と風速を表示
      fill(0, 0, 20);
      text(date, x + barW/2, y + barH + 16);  //日付を表示
    } else {
      
      over = false;
    }
  }
}