String[] date; //日付
float[] temp;    //気温
float highTemp;  //最高気温
float lowTemp;  //最低気温
PFont font;
float barW;            //バーの幅
float barH = 200;            //バーの高さ
float margin = 25;    //余白
boolean over = false;  //マウスがバーの上にあるかを判定
float space = 1;       //バー同士の隙間 
 
void setup() {
  size(1500, 250);
  colorMode(HSB, 360, 100, 100);  //HSBモードにする
  noStroke();
  loadData();  //データ読み込み、オブジェクト化
 
  //一番低い気温と高い気温をtemp配列内で検索し、lowTemp、highTempに入れる
  lowTemp = min(temp);
  highTemp = max(temp);
 
  //画面サイズと余白分を計算してバーの幅を決める
  barW = (width - margin * 2 - space * (temp.length - 1)) / float(temp.length);
 
  font = createFont("Arial", 11);
  textFont(font, 11);
  textAlign(CENTER);
}
 
void draw() {
  background(0, 0, 100);
 
  //
  for (int i = 0; i < temp.length; i ++) {
 
    float x = i * (barW + space) + margin;
    float y = margin;
 
    if (mouseX > x && mouseX < x + barW && mouseY > y && mouseY < y + barH) {
 
      fill(0, 0, 20);      
      text("気温" + temp[i] + "℃", x + barW/2, y - 8);  //気温と風速を表示
      text(date[i], x + barW/2, y + barH + 16);  //日付を表示
 
      //気温を色に変換
      fill(createColor(temp[i], lowTemp, highTemp), 100, 100);
    } else {
      fill(createColor(temp[i], lowTemp, highTemp), 30, 100);
    }      
 
    rect(x, y, barW, barH);
  }
}
 
void loadData() {
  //ファイルをロードして配列を作る
  JSONArray weatherData = loadJSONArray("weather_day.json");
 
  //要素数を取得して配列を生成
  date = new String[weatherData.size()];
  temp = new float[weatherData.size()];
 
  for (int i = 0; i < weatherData.size(); i++) {
 
    //一つ一つのJSON配列の中を検索
    JSONObject weather = weatherData.getJSONObject(i); 
 
    //date, temp, wind配列に一つずつ入れる
    date[i] = weather.getString("date");
    temp[i] = weather.getFloat("temp");
  }
}
 
//気温から色を決定
float createColor(float _temp, float _lowTemp, float _highTemp) {
 
  //最低気温から最高気温の範囲を、色相の200°から0°に変換
  //気温を色に変換
  float barColor = map(_temp, _lowTemp, _highTemp, 200, 0);
 
  return barColor;
}