String[] date; //日付 //<>//
float[] temp;    //気温
float highTemp;  //最高気温
float lowTemp;  //最低気温
PFont font;

Month []monthData = new Month[12];//月ごとのデータを格納するオブジェクト

void setup() {
  size(400, 700);
  loadData();
  colorMode(HSB, 360, 100, 100);  //HSBモードにする
  noStroke();

  //一番低い気温と高い気温をtemp配列内で検索し、lowTemp、highTempに入れる
  lowTemp = min(temp);
  highTemp = max(temp);

  //Monthオブジェクトを生成
  for (int i = 0; i < 12; i++) {
    monthData[i] = new Month();
  }

  //Monthオブジェクトに月ごとのデータを格納していく
  for (int i = 0; i<date.length; i++) {
    String []splitStr = split(date[i], '/');
    int arrNum = Integer.parseInt(splitStr[0])-1;
    monthData[arrNum].setNum(date[i], temp[i]);
  }

  //フォントの生成
  font = createFont("Arial", 11);
  textFont(font, 11);
  textAlign(CENTER);
}

void draw() {
  background(360);

  float visualWidth = 25*11;//円全体の横幅
  float visualHeight = 20*30;//円の全体の横幅
  float leftMargin = (width-visualWidth)/2;//左のマージン
  float topMargin = (height-visualHeight)/2+8;//上のマージン

  //月ごとにループする
  for (int i = 0; i < 12; i++) {

    //日付ごとにループする
    for (int k = 0; k <  monthData[i].temp.size(); k++) {
      float temp = monthData[i].temp.get(k);//温度を取得
      fill(createColor(temp, lowTemp, highTemp), 90, 100);//色を設定
      float eSize = map(temp, lowTemp, highTemp, 3, 20);//円の大きさの範囲を3~20にする
      ellipse(i*25+leftMargin, (k*20)+topMargin, eSize, eSize);//縦に月ごとに描画していく
    }

    //月のテキストの描画
    fill(0, 0, 24);    
    text(String.valueOf(i+1)+"月", i*25+leftMargin, 40);
  }
}

//月ごとのデータを格納する
class Month {
  ArrayList<String> date = new ArrayList<String>();//日付
  ArrayList<Float> temp = new ArrayList<Float>();//気温

  void setNum(String _date, float _temp) {
    date.add(_date);
    temp.add(_temp);
  }
}


void loadData() {
  //ファイルをロードして配列を作る
  JSONArray weatherData = loadJSONArray("weather_day.json");

  //要素数を取得して配列を生成
  date = new String[weatherData.size()];
  temp = new float[weatherData.size()];

  for (int i = 0; i < weatherData.size(); i++) {

    //一つ一つのJSON配列の中を検索
    JSONObject weather = weatherData.getJSONObject(i);

    //date, temp配列に一つずつ入れる
    date[i] = weather.getString("date");
    temp[i] = weather.getFloat("temp");
  }
}

//気温から色を決定
float createColor(float _temp, float _lowTemp, float _highTemp) {

  //最低気温から最高気温の範囲を、色相の200°から0°に変換
  //気温を色に変換
  float barColor = map(_temp, _lowTemp, _highTemp, 200, 0);

  return barColor;
}